diff --git a/gcc/analyzer/impl-4.cc b/gcc/analyzer/impl-4.cc
index b12102c..5089c16 100644
--- a/gcc/analyzer/impl-4.cc
+++ b/gcc/analyzer/impl-4.cc
@@ -42,8 +42,15 @@
 #include "tristate.h"
 #include "selftest.h"
 #include "digraph.h"
-#include "constraints.h"
-//#include "tree-ssa-operands.h"
+#include "path-state.h"
+#include "tree-ssa-operands.h"
+#include "tree-vrp.h"
+#include "gimple-ssa.h"
+#include "tree-ssanames.h"
+#include "tree-phinodes.h"
+#include "ssa-iterators.h"
+#include "region-model.h"
+#include "tree-diagnostic.h"
 
 /* Overview:
 
@@ -100,8 +107,11 @@ namespace impl_4 {
 class exploded_graph;
 class exploded_node;
 class exploded_edge;
+class exploded_path;
 class checker4_path;
 class stmt_finder;
+class state_purge_per_ssa_name;
+class shortest_paths;
 
 ////////////////////////////////////////////////////////////////////////////
 
@@ -157,6 +167,24 @@ struct pod_hash_traits : typed_noop_remove<Type>
 
 ////////////////////////////////////////////////////////////////////////////
 
+class format
+{
+public:
+  format (bool newlines) : m_newlines (newlines) {}
+
+  void spacer (pretty_printer *pp) const
+  {
+    if (m_newlines)
+      pp_newline (pp);
+    else
+      pp_space (pp);
+  }
+
+  bool m_newlines;
+};
+
+///////////////////////////////////////////////////////////////////////////
+
 /* A string of return_superedge pointers, representing a call stack
    at a program point.
 
@@ -265,9 +293,9 @@ public:
   {
   }
 
-  void print (pretty_printer *pp) const;
+  void print (pretty_printer *pp, const format &f) const;
   void print_source_line (pretty_printer *pp) const;
-  std::string to_str () const;
+  std::string to_str (const format &f) const;
 
   hashval_t hash () const;
   bool operator== (const program_point &other) const
@@ -347,7 +375,7 @@ public:
     return program_point (NULL, NULL, 0, PK_DELETED, call_string ());
   }
 
-  bool on_edge (const exploded_graph &eg,
+  bool on_edge (exploded_graph &eg,
 		const superedge *succ);
 
 //private:
@@ -358,6 +386,127 @@ public:
   call_string m_call_string;
 };
 
+} // namespace impl_4
+
+using impl_4::pod_hash_traits;
+using impl_4::program_point;
+
+template <> struct default_hash_traits<program_point>
+: public pod_hash_traits<program_point>
+{
+};
+
+template <>
+inline hashval_t
+pod_hash_traits<program_point>::hash (value_type v)
+{
+  return v.hash ();
+}
+
+template <>
+inline bool
+pod_hash_traits<program_point>::equal (const value_type &existing,
+                                 const value_type &candidate)
+{
+  return existing == candidate;
+}
+template <>
+inline void
+pod_hash_traits<program_point>::mark_deleted (value_type &v)
+{
+  v = program_point::deleted ();
+}
+template <>
+inline void
+pod_hash_traits<program_point>::mark_empty (value_type &v)
+{
+  v = program_point::empty ();
+}
+template <>
+inline bool
+pod_hash_traits<program_point>::is_deleted (value_type v)
+{
+  return v.m_kind == PK_DELETED;
+}
+template <>
+inline bool
+pod_hash_traits<program_point>::is_empty (value_type v)
+{
+  return v.m_kind == PK_EMPTY;
+}
+
+namespace impl_4 {
+
+////////////////////////////////////////////////////////////////////////////
+
+/* The result of analyzing which SSA names can be purged from state at
+   different points in the program, so that we can simplify program_state
+   objects, in the hope of reducing state-blowup.  */
+
+class state_purge_map : public log_user
+{
+public:
+  typedef hash_map<tree, state_purge_per_ssa_name *> map_t;
+  typedef map_t::iterator iterator;
+
+  state_purge_map (const supergraph &sg, logger *logger);
+  ~state_purge_map ();
+
+  const state_purge_per_ssa_name &get_data_for_ssa_name (tree var) const
+  {
+    gcc_assert (TREE_CODE (var) == SSA_NAME);
+    state_purge_per_ssa_name **slot
+      = const_cast <map_t&> (m_map).get (var);
+    return **slot;
+  }
+
+  iterator begin () const { return m_map.begin (); }
+  iterator end () const { return m_map.end (); }
+
+  //private:
+  const supergraph &m_sg;
+  map_t m_map;
+};
+
+/* The part of a state_purge_map relating to a specific SSA name.
+
+   The result of analyzing a given SSA name, recording which
+   program_points need to retain state information about it to handle
+   their successor states, so that we can simplify program_state objects,
+   in the hope of reducing state-blowup.  */
+
+class state_purge_per_ssa_name
+{
+public:
+  state_purge_per_ssa_name (const state_purge_map &map,
+			    tree var,
+			    function *fun);
+
+  bool needed_at_point_p (const program_point &point) const;
+
+  /* FIXME: this stores points, but ignores interprocedural issues;
+     everything will be at depth 0.  */
+  /* Should we build a program_point graph first???  */
+
+private:
+  static program_point before_use_stmt (const state_purge_map &map,
+					const gimple *use_stmt);
+
+  void add_to_worklist (const program_point &point,
+			auto_vec<program_point *> *worklist,
+			logger *logger);
+
+  void process_point (const program_point &point,
+		      auto_vec<program_point *> *worklist,
+		      logger *logger);
+
+  typedef hash_set<program_point> point_set_t;
+  point_set_t m_points_needing_var;
+  tree m_var;
+};
+
+////////////////////////////////////////////////////////////////////////////
+
 /* Data shared by all program_state instances.  */
 
 class extrinsic_state
@@ -435,13 +584,17 @@ namespace impl_4 {
 /* Map from var to state machine state, also capturing the origin of
    each state.  */
 
+template<typename Expr_T>
 class sm_state_map
 {
 public:
+  typedef Expr_T expr_t;
+
+  /* An entry in a hash_map.  */
   struct entry_t
   {
     entry_t (state_machine::state_t state,
-	     path_var origin)
+	     expr_t origin)
     : m_state (state), m_origin (origin)
     {}
 
@@ -456,10 +609,10 @@ public:
     }
 
     state_machine::state_t m_state;
-    path_var m_origin;
+    expr_t m_origin;
   };
-  typedef hash_map <path_var, entry_t> map_t;
-  typedef map_t::iterator iterator_t;
+  typedef hash_map <expr_t, entry_t> map_t;
+  typedef typename map_t::iterator iterator_t;
 
   sm_state_map *clone () const;
 
@@ -476,20 +629,28 @@ public:
     return !(*this == other);
   }
 
-  state_machine::state_t get_state (path_var pv) const;
-  path_var get_origin (path_var pv) const;
+  state_machine::state_t get_state (expr_t pv) const;
+  expr_t get_origin (expr_t pv) const;
 
-  void set_state (path_state *ps, path_var pv, state_machine::state_t state,
-		  path_var origin);
-  void set_state (const equiv_class &ec,
+  void set_state (path_state *ps, expr_t pv, state_machine::state_t state,
+		  expr_t origin);
+  void set_state (const psn::equiv_class &ec,
 		  state_machine::state_t state,
-		  path_var origin);
-  void impl_set_state (path_var pv,
+		  expr_t origin);
+  void impl_set_state (expr_t pv,
 		       state_machine::state_t state,
-		       path_var origin);
+		       expr_t origin);
 
   void purge_stack_frame (int callee_stack_depth);
 
+  void purge_for_unknown_fncall (const exploded_graph &eg,
+				 const state_machine &sm,
+				 const gcall *call, tree fndecl,
+				 path_state *new_ps);
+
+  int purge (const state_machine &sm,
+	     const psn::purge_criteria &p);
+
   iterator_t begin () const { return m_map.begin (); }
   iterator_t end () const { return m_map.end (); }
 
@@ -503,13 +664,13 @@ private:
    Currently this is a combination of:
    - a path_state giving a set of equivalence classes of path_vars and
      inequalities between them
+   - an optional region_model, for when -fanalyzer-region-model is enabled
    - sm_state_maps per state machine, giving a sparse mapping of
      path_vars to states.  */
 
 class program_state
 {
 public:
-  program_state (int num_checkers);
   program_state (const extrinsic_state &ext_state);
   program_state (const program_state &other);
   program_state& operator= (const program_state &other);
@@ -521,23 +682,30 @@ public:
 	      pretty_printer *pp) const;
   std::string to_str (const extrinsic_state &ext_state) const;
 
-  equiv_class &get_ec (path_var pv)
+  void dump (const extrinsic_state &ext_state,
+	     pretty_printer *pp) const;
+
+  psn::equiv_class &get_ec (path_var pv)
   {
-    equiv_class_id ec_id = m_path_state.get_or_add_equiv_class (pv);
+    psn::equiv_class_id ec_id = m_path_state.get_or_add_equiv_class (pv);
     return ec_id.get_obj (m_path_state);
   }
 
-  program_state prune_for_point (const exploded_graph &eg,
+  program_state prune_for_point (exploded_graph &eg,
 				 const program_point &point) const;
 
-  bool on_edge (const exploded_graph &eg,
+  bool on_edge (exploded_graph &eg,
 		const exploded_node &enode,
 		const superedge *succ);
 
+  void validate () const;
+
   //private:
   path_state m_path_state;
 
-  auto_vec<sm_state_map *> m_checker_states;
+  region_model *m_region_model;
+
+  auto_delete_vec<sm_state_map<path_var> > m_checker_states;
 };
 
 /* A <program_point, program_state> pair, used internally by
@@ -557,63 +725,15 @@ struct point_and_state
   {
     return m_point.hash () ^ m_state.hash ();
   }
+  bool operator== (const point_and_state &other) const
+  {
+    return m_point == other.m_point && m_state == other.m_state;
+  }
 
   program_point m_point;
   program_state m_state;
 };
 
-} // namespace impl_4
-
-using impl_4::point_and_state;
-using impl_4::pod_hash_traits;
-
-template <> struct default_hash_traits<point_and_state>
-: public pod_hash_traits<point_and_state>
-{
-};
-
-template <>
-inline hashval_t
-pod_hash_traits<point_and_state>::hash (value_type v)
-{
-  return v.hash ();
-}
-
-template <>
-inline bool
-pod_hash_traits<point_and_state>::equal (const value_type &existing,
-					 const value_type &candidate)
-{
-  return (existing.m_point == candidate.m_point
-	  && existing.m_state == candidate.m_state);
-}
-template <>
-inline void
-pod_hash_traits<point_and_state>::mark_deleted (value_type &v)
-{
-  v = point_and_state (program_point::deleted (), program_state (0));
-}
-template <>
-inline void
-pod_hash_traits<point_and_state>::mark_empty (value_type &v)
-{
-  v = point_and_state (program_point::empty (), program_state (0));
-}
-template <>
-inline bool
-pod_hash_traits<point_and_state>::is_deleted (value_type v)
-{
-  return (v.m_point.m_kind == PK_DELETED);
-}
-template <>
-inline bool
-pod_hash_traits<point_and_state>::is_empty (value_type v)
-{
-  return (v.m_point.m_kind == PK_EMPTY);
-}
-
-namespace impl_4 {
-
 /* An exploded_node is a unique, immutable <point, state> pair within the
    exploded_graph.
    Each exploded_node has a unique index within the graph
@@ -629,11 +749,17 @@ class exploded_node : public dnode
   {
   }
 
+  hashval_t hash () const { return m_ps.hash (); }
+
   void dump_dot (graphviz_out *gv) const FINAL OVERRIDE;
   void dump_dot_id (pretty_printer *pp) const;
 
-  program_state on_stmt (const exploded_graph &eg) const;
-  bool on_edge (const exploded_graph &eg,
+  void dump_to_pp (pretty_printer *pp) const;
+  void dump (FILE *fp) const;
+  void dump () const;
+
+  program_state on_stmt (exploded_graph &eg) const;
+  bool on_edge (exploded_graph &eg,
 		const superedge *succ,
 		program_point *next_point,
 		program_state *next_state) const;
@@ -644,13 +770,26 @@ class exploded_node : public dnode
 		      const program_state &old_state,
 		      program_state *new_state) const;
 
+  void on_assignment_for_region_model (const exploded_graph &eg,
+				       const gassign *stmt,
+				       const program_state &old_state,
+				       program_state *new_state) const;
+  void on_call_for_region_model (const exploded_graph &eg,
+				 const gcall *stmt,
+				 const program_state &old_state,
+				 program_state *new_state) const;
+  void on_return_for_region_model (const exploded_graph &eg,
+				   const greturn *return_,
+				   const program_state &old_state,
+				   program_state *new_state) const;
+
   void copy_sm_state (const exploded_graph &eg,
 		      path_var lhs,
 		      path_var rhs,
 		      const program_state &old_state,
 		      program_state *new_state) const;
 
-  void detect_leaks (const exploded_graph &eg) const;
+  void detect_leaks (exploded_graph &eg) const;
 
   const program_point &get_point () const { return m_ps.m_point; }
   const supernode *get_supernode () const
@@ -668,6 +807,8 @@ class exploded_node : public dnode
 
   const program_state &get_state () const { return m_ps.m_state; }
 
+  const point_and_state *get_key () const { return &m_ps; }
+
 private:
   /* The <program_point, program_state> pair.  This is const, as it
      is immutable once the exploded_node has been created.  */
@@ -696,9 +837,139 @@ class exploded_edge : public dedge
   void dump_dot (graphviz_out *gv) const FINAL OVERRIDE;
 
   //private:
-  exploded_node *m_src;
-  exploded_node *m_dest;
-  const superedge *m_sedge;
+  exploded_node *const m_src;
+  exploded_node *const m_dest;
+  const superedge *const m_sedge;
+};
+
+/* Statistics about aspects of an exploded_graph.  */
+
+struct stats
+{
+  stats (int num_supernodes);
+  void log (logger *logger) const;
+  void dump (FILE *out) const;
+
+  int m_num_nodes[NUM_POINT_KINDS];
+  int m_node_reuse_count;
+  int m_path_vars_purged;
+  int m_num_supernodes;
+};
+
+/* FIXME.  */
+
+struct eg_hash_map_traits
+{
+  typedef const point_and_state *key_type;
+  typedef exploded_node *value_type;
+  typedef exploded_node *compare_type;
+
+  static inline hashval_t hash (const key_type &v)
+  {
+    return v->hash ();
+  }
+  static inline bool equal_keys (const key_type &k1, const key_type &k2)
+  {
+    return *k1 == *k2;
+  }
+  template <typename T>
+  static inline void remove (T &)
+  {
+    /* empty; the nodes are handled elsewhere.  */
+  }
+  template <typename T>
+  static inline void mark_deleted (T &entry)
+  {
+    entry.m_key = reinterpret_cast<key_type> (1);
+  }
+  template <typename T>
+  static inline void mark_empty (T &entry)
+  {
+    entry.m_key = NULL;
+  }
+  template <typename T>
+  static inline bool is_deleted (const T &entry)
+  {
+    return entry.m_key == reinterpret_cast<key_type> (1);
+  }
+  template <typename T>
+  static inline bool is_empty (const T &entry)
+  {
+    return entry.m_key == NULL;
+  }
+};
+
+/* A to-be-emitted diagnostic stored within diagnostic_manager.  */
+
+class saved_diagnostic
+{
+public:
+  saved_diagnostic (const state_machine &sm,
+		    const exploded_node *enode,
+		    const supernode *node, const gimple *stmt,
+		    stmt_finder *stmt_finder,
+		    tree var, state_machine::state_t state,
+		    pending_diagnostic *d);
+  ~saved_diagnostic ();
+
+  bool operator== (const saved_diagnostic &other) const
+  {
+    return (&m_sm == &other.m_sm
+	    /* We don't compare m_enode.  */
+	    && m_node == other.m_node
+	    && m_stmt == other.m_stmt
+	    /* We don't compare m_stmt_finder.  */
+	    && m_var == other.m_var
+	    && m_state == other.m_state
+	    && m_d->equal_p (*other.m_d));
+  }
+
+  //private:
+  const state_machine &m_sm;
+  const exploded_node *m_enode;
+  const supernode *m_node;
+  const gimple *m_stmt;
+  stmt_finder *m_stmt_finder;
+  tree m_var;
+  state_machine::state_t m_state;
+  pending_diagnostic *m_d;
+};
+
+/* A class with responsibility for saving pending diagnostics, so that
+   they can be emitted after the exploded_graph is complete.
+   This lets us de-duplicate diagnostics, and find the shortest path
+   for each similar diagnostic, potentially using edges that might
+   not have been found when each diagnostic was first saved.
+
+   This also lets us compute shortest_paths once, rather than
+   per-diagnostic.  */
+
+class diagnostic_manager : public log_user
+{
+public:
+  diagnostic_manager (logger *logger, int verbosity);
+
+  void add_diagnostic (const state_machine &sm,
+		       const exploded_node *enode,
+		       const supernode *node, const gimple *stmt,
+		       stmt_finder *finder,
+		       tree var, state_machine::state_t state,
+		       pending_diagnostic *d);
+
+  void emit_saved_diagnostics (const exploded_graph &eg);
+  void emit_saved_diagnostic (const exploded_graph &eg,
+			      const saved_diagnostic &sd,
+			      const exploded_path &epath,
+			      const gimple *stmt,
+			      int num_dupes);
+
+  void prune_path (checker4_path *path,
+		   const state_machine &sm,
+		   tree var, state_machine::state_t state) const;
+
+private:
+  auto_delete_vec<saved_diagnostic> m_saved_diagnostics;
+  const int m_verbosity;
 };
 
 /* An exploded_graph is a directed graph of unique <point, state> pairs.
@@ -710,10 +981,13 @@ class exploded_graph : public digraph, public log_user
 public:
   exploded_graph (const supergraph &sg, logger *logger,
 		  const extrinsic_state &ext_state,
+		  const state_purge_map *purge_map,
 		  int verbosity);
+  ~exploded_graph ();
 
   const supergraph &get_supergraph () const { return m_sg; }
   const extrinsic_state &get_ext_state () const { return m_ext_state; }
+  const state_purge_map *get_purge_map () const { return m_purge_map; }
 
   exploded_node *get_origin () const { return m_origin; }
 
@@ -727,23 +1001,33 @@ public:
   void add_edge (exploded_node *src, exploded_node *dest,
 		 const superedge *sedge);
 
-  void emit_diagnostic (const state_machine &sm,
+  void save_diagnostic (const state_machine &sm,
 			const exploded_node *enode,
 			const supernode *node, const gimple *stmt,
 			stmt_finder *finder,
 			tree var, state_machine::state_t state,
-			pending_diagnostic *d) const;
-  void prune_path (checker4_path *path,
-		   const state_machine &sm,
-		   tree var, state_machine::state_t state) const;
+			pending_diagnostic *d);
+
+  diagnostic_manager &get_diagnostic_manager ()
+  {
+    return m_diagnostic_manager;
+  }
 
+  stats *get_global_stats () { return &m_global_stats; }
+  stats *get_or_create_function_stats (function *fn);
   void log_stats () const;
+  void dump_stats (FILE *) const;
+  void dump_states_for_supernode (FILE *, const supernode *snode) const;
 
 private:
   const supergraph &m_sg;
 
-  /* Map from point/state to exploded node.  */
-  typedef hash_map <point_and_state, exploded_node *> map_t;
+  /* Map from point/state to exploded node.
+     To avoid duplication we store point_and_state
+     *pointers* as keys, rather than point_and_state, using the
+     instance from within the exploded_node, with a custom hasher.  */
+  typedef hash_map <const point_and_state *, exploded_node *,
+		    eg_hash_map_traits> map_t;
   map_t m_point_and_state_to_node;
 
   auto_vec<exploded_node *> m_worklist;
@@ -752,11 +1036,15 @@ private:
 
   const extrinsic_state &m_ext_state;
 
-  int m_verbosity;
+  const state_purge_map *const m_purge_map;
+
+  diagnostic_manager m_diagnostic_manager;
 
   /* Stats.  */
-  int m_num_nodes[NUM_POINT_KINDS];
-  int m_node_reuse_count;
+  stats m_global_stats;
+  typedef hash_map<function *, stats *> function_stat_map_t;
+  function_stat_map_t m_per_function_stats;
+  auto_vec<int> m_PK_AFTER_SUPERNODE_per_snode;
 };
 
 /* A path within an exploded_graph: a sequence of edges.  */
@@ -768,6 +1056,8 @@ public:
   exploded_path (const exploded_path &other);
   exploded_path & operator= (const exploded_path &other);
 
+  unsigned length () const { return m_edges.length (); }
+
   bool find_stmt_backwards (const gimple *search_stmt,
 			    int *out_idx) const;
 
@@ -806,6 +1096,8 @@ private:
 class stmt_finder
 {
 public:
+  virtual ~stmt_finder () {}
+  virtual stmt_finder *clone () const = 0;
   virtual const gimple *find_stmt (const exploded_path &epath) = 0;
 };
 
@@ -1322,6 +1614,7 @@ public:
 			   enode->get_stack_depth (),
 			   msg);
     add_event (end_of_path);
+    free (msg);
   }
 
   void prepare_for_emission (pending_diagnostic *pd)
@@ -1462,11 +1755,11 @@ call_string::calc_recursion_depth () const
 /* FIXME.  */
 
 void
-program_point::print (pretty_printer *pp) const
+program_point::print (pretty_printer *pp, const format &f) const
 {
   pp_string (pp, "callstring: ");
   m_call_string.print (pp);
-  pp_newline (pp);
+  f.spacer (pp);
 
   switch (m_kind)
     {
@@ -1475,7 +1768,6 @@ program_point::print (pretty_printer *pp) const
 
     case PK_ORIGIN:
       pp_printf (pp, "origin");
-      pp_newline (pp);
       break;
 
     case PK_BEFORE_SUPERNODE:
@@ -1486,7 +1778,7 @@ program_point::print (pretty_printer *pp) const
 	else
 	  pp_printf (pp, "before SN: %i (NULL from-edge)",
 		     m_supernode->m_index);
-	pp_newline (pp);
+	f.spacer (pp);
 	for (gphi_iterator gpi
 	       = const_cast<supernode *>(get_supernode ())->start_phis ();
 	     !gsi_end_p (gpi); gsi_next (&gpi))
@@ -1494,7 +1786,6 @@ program_point::print (pretty_printer *pp) const
 	    gphi *phi = gpi.phi ();
 	    pp_gimple_stmt_1 (pp, const_cast <gphi *> (phi),
 			      0, (dump_flags_t)0);
-	    pp_newline (pp);
 	  }
       }
       break;
@@ -1502,26 +1793,25 @@ program_point::print (pretty_printer *pp) const
     case PK_BEFORE_STMT:
       pp_printf (pp, "before (SN: %i stmt: %i): ", m_supernode->m_index,
 		 m_stmt_idx);
-      pp_newline (pp);
+      f.spacer (pp);
       pp_gimple_stmt_1 (pp, const_cast <gimple *> (get_stmt ()),
 			0, (dump_flags_t)0);
-      pp_newline (pp);
-      print_source_line (pp);
+      if (f.m_newlines)
+	print_source_line (pp);
       break;
 
     case PK_AFTER_STMT:
       pp_printf (pp, "after (SN: %i stmt: %i): ", m_supernode->m_index,
 		 m_stmt_idx);
-      pp_newline (pp);
+      f.spacer (pp);
       pp_gimple_stmt_1 (pp, const_cast <gimple *> (get_stmt ()),
 			0, (dump_flags_t)0);
-      pp_newline (pp);
-      print_source_line (pp);
+      if (f.m_newlines)
+	print_source_line (pp);
       break;
 
     case PK_AFTER_SUPERNODE:
       pp_printf (pp, "after SN: %i", m_supernode->m_index);
-      pp_newline (pp);
       break;
     }
 }
@@ -1538,6 +1828,10 @@ public:
     show_line_numbers_p = true;
     show_caret = true;
   }
+  ~debug_diagnostic_context ()
+  {
+    diagnostic_finish (this);
+  }
 };
 
 /* FIXME.  */
@@ -1558,10 +1852,10 @@ program_point::print_source_line (pretty_printer *pp) const
 /* FIXME.  */
 
 std::string
-program_point::to_str () const
+program_point::to_str (const format &f) const
 {
   pretty_printer pp;
-  print (&pp);
+  print (&pp, f);
   return std::string (pp_formatted_text (&pp));
 }
 
@@ -1595,19 +1889,21 @@ program_point::get_stmt () const
 
 /* FIXME.  */
 
-sm_state_map *
-sm_state_map::clone () const
+template <typename Expr_T>
+sm_state_map<Expr_T> *
+sm_state_map<Expr_T>::clone () const
 {
   return new sm_state_map (*this);
 }
 
 /* FIXME.  */
 
+template <typename Expr_T>
 void
-sm_state_map::print (const state_machine &sm, pretty_printer *pp) const
+sm_state_map<Expr_T>::print (const state_machine &sm, pretty_printer *pp) const
 {
   pp_string (pp, "{");
-  for (map_t::iterator iter = m_map.begin ();
+  for (typename map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
@@ -1626,8 +1922,9 @@ sm_state_map::print (const state_machine &sm, pretty_printer *pp) const
 
 /* FIXME.  */
 
+template <typename Expr_T>
 std::string
-sm_state_map::to_str (const state_machine &sm) const
+sm_state_map<Expr_T>::to_str (const state_machine &sm) const
 {
   pretty_printer pp;
   print (sm, &pp);
@@ -1636,19 +1933,21 @@ sm_state_map::to_str (const state_machine &sm) const
 
 /* FIXME.  */
 
+template <typename Expr_T>
 bool
-sm_state_map::is_empty_p () const
+sm_state_map<Expr_T>::is_empty_p () const
 {
   return m_map.elements () == 0;
 }
 
 /* FIXME.  */
 
+template <typename Expr_T>
 hashval_t
-sm_state_map::hash () const
+sm_state_map<Expr_T>::hash () const
 {
   inchash::hash hstate;
-  for (map_t::iterator iter = m_map.begin ();
+  for (typename map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
@@ -1663,13 +1962,14 @@ sm_state_map::hash () const
 
 /* FIXME.  */
 
+template <typename Expr_T>
 bool
-sm_state_map::operator== (const sm_state_map &other) const
+sm_state_map<Expr_T>::operator== (const sm_state_map &other) const
 {
   if (m_map.elements () != other.m_map.elements ())
     return false;
 
-  for (map_t::iterator iter = m_map.begin ();
+  for (typename map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
@@ -1686,8 +1986,9 @@ sm_state_map::operator== (const sm_state_map &other) const
 
 /* FIXME.  */
 
+template <typename Expr_T>
 state_machine::state_t
-sm_state_map::get_state (path_var pv) const
+sm_state_map<Expr_T>::get_state (Expr_T pv) const
 {
   if (entry_t *slot
       = const_cast <map_t &> (m_map).get (pv))
@@ -1698,8 +1999,9 @@ sm_state_map::get_state (path_var pv) const
 
 /* FIXME.  */
 
-path_var
-sm_state_map::get_origin (path_var pv) const
+template <typename Expr_T>
+Expr_T
+sm_state_map<Expr_T>::get_origin (Expr_T pv) const
 {
   entry_t *slot
     = const_cast <map_t &> (m_map).get (pv);
@@ -1709,33 +2011,37 @@ sm_state_map::get_origin (path_var pv) const
 
 /* FIXME.  */
 
+template <typename Expr_T>
 void
-sm_state_map::set_state (path_state *ps,
-			 path_var pv,
+sm_state_map<Expr_T>::set_state (path_state *ps,
+			 Expr_T pv,
 			 state_machine::state_t state,
-			 path_var origin)
+			 Expr_T origin)
 {
-  equiv_class &ec = ps->get_equiv_class (pv);
+  psn::equiv_class &ec = ps->get_equiv_class (pv);
   set_state (ec, state, origin);
 }
 
 /* FIXME.  */
 
+template <typename Expr_T>
 void
-sm_state_map::set_state (const equiv_class &ec, state_machine::state_t state,
-			 path_var origin)
+sm_state_map<Expr_T>::set_state (const psn::equiv_class &ec,
+			 state_machine::state_t state,
+			 Expr_T origin)
 {
   int i;
-  path_var *pv;
+  Expr_T *pv;
   FOR_EACH_VEC_ELT (ec.m_vars, i, pv)
     impl_set_state (*pv, state, origin);
 }
 
 /* Set state of PV to STATE, bypassing equivalence classes.  */
 
+template <typename Expr_T>
 void
-sm_state_map::impl_set_state (path_var pv, state_machine::state_t state,
-			      path_var origin)
+sm_state_map<Expr_T>::impl_set_state (Expr_T pv, state_machine::state_t state,
+				      Expr_T origin)
 {
   /* Special-case state 0 as the default value.  */
   if (state == 0)
@@ -1749,24 +2055,99 @@ sm_state_map::impl_set_state (path_var pv, state_machine::state_t state,
 
 /* FIXME.  */
 
+template <typename Expr_T>
 void
-sm_state_map::purge_stack_frame (int callee_stack_depth)
+sm_state_map<Expr_T>::purge_stack_frame (int callee_stack_depth)
 {
   /* FIXME: not sure how to safely remove during a traversal, so for now
      do it in two stages.  */
-  auto_vec <path_var> keys;
-  for (map_t::iterator iter = m_map.begin ();
+  auto_vec <Expr_T> keys;
+  for (typename map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     keys.safe_push ((*iter).first);
 
   int i;
-  path_var *pv;
+  Expr_T *pv;
   FOR_EACH_VEC_ELT (keys, i, pv)
     if (pv->m_stack_depth >= callee_stack_depth)
       m_map.remove (*pv);
 }
 
+/* FIXME.  */
+
+template <>
+void
+sm_state_map<path_var>::purge_for_unknown_fncall (const exploded_graph &eg,
+						  const state_machine &sm,
+						  const gcall *call,
+						  tree fndecl,
+						  path_state *new_ps)
+{
+  if (fndecl)
+    eg.log ("function %qE is unknown to checker %qs",
+	    fndecl, sm.get_name ());
+  else
+    eg.log ("unknown function pointer for checker %qs",
+	    sm.get_name ());
+
+  /* Unknown function body, which could do anything to the
+     states passed to it.
+     Clear any state for the params and any LHS.  */
+  tree iter_param_types = NULL_TREE;
+  if (fndecl)
+    iter_param_types = TYPE_ARG_TYPES (TREE_TYPE (fndecl));
+  for (int arg_idx = 0; arg_idx < gimple_call_num_args (call); arg_idx++)
+    {
+      /* Track expected param type, where available.  */
+      if (iter_param_types)
+	{
+	  tree param_type = TREE_VALUE (iter_param_types);
+	  gcc_assert (param_type);
+	  iter_param_types = TREE_CHAIN (iter_param_types);
+
+	  /* Don't purge state if it was passed as a const pointer
+	     e.g. for things like strlen (PTR).  */
+	  if (TREE_CODE (param_type) == POINTER_TYPE)
+	    if (TYPE_READONLY (TREE_TYPE (param_type)))
+	      continue;
+	}
+
+      set_state (new_ps,
+		 new_ps->make_path_var (gimple_call_arg (call, arg_idx)),
+		 0, path_var (NULL_TREE, 0));
+    }
+
+  if (gimple_call_lhs (call))
+    set_state (new_ps,
+	       new_ps->make_path_var (gimple_call_lhs (call)),
+	       0, path_var (NULL_TREE, 0));
+}
+
+template <>
+int
+sm_state_map<path_var>::purge (const state_machine &sm,
+			       const psn::purge_criteria &p)
+{
+  /* FIXME: not sure how to safely remove during a traversal, so for now
+     do it in two stages.  */
+  auto_vec<path_var> to_remove;
+  for (typename map_t::iterator iter = m_map.begin ();
+       iter != m_map.end ();
+       ++iter)
+    {
+      if (p.should_purge_p ((*iter).first)
+	  && sm.can_purge_p ((*iter).second.m_state))
+	to_remove.safe_push ((*iter).first);
+    }
+
+  int i;
+  path_var *pv;
+  FOR_EACH_VEC_ELT (to_remove, i, pv)
+    m_map.remove (*pv);
+
+  return to_remove.length ();
+}
 
 ////////////////////////////////////////////////////////////////////////////
 
@@ -1775,7 +2156,7 @@ sm_state_map::purge_stack_frame (int callee_stack_depth)
 class impl_sm_context : public sm_context, public log_user
 {
 public:
-  impl_sm_context (const exploded_graph &eg,
+  impl_sm_context (exploded_graph &eg,
 		   const state_machine &sm,
 		   const exploded_node *node,
 
@@ -1783,8 +2164,8 @@ public:
 		      old state, rather than the new?  */
 		   program_state *new_state,
 
-		   const sm_state_map &old_smap,
-		   sm_state_map *new_smap,
+		   const sm_state_map<path_var> &old_smap,
+		   sm_state_map<path_var> *new_smap,
 
 		   stmt_finder *stmt_finder = NULL)
   : log_user (eg.get_logger ()), m_eg (eg), m_sm (sm), m_node (node),
@@ -1829,18 +2210,20 @@ public:
     state_machine::state_t current = m_old_smap.get_state (pv);
     if (state == current)
       {
-	m_eg.emit_diagnostic (m_sm, m_node, node, stmt, m_stmt_finder,
-			      var, state, d);
+	m_eg.get_diagnostic_manager ().add_diagnostic
+	  (m_sm, m_node, node, stmt, m_stmt_finder,
+	   var, state, d);
       }
-    delete d;
+    else
+      delete d;
   }
 
-  const exploded_graph &m_eg;
+  exploded_graph &m_eg;
   const state_machine &m_sm;
   const exploded_node *m_node;
   program_state *m_new_state;
-  const sm_state_map &m_old_smap;
-  sm_state_map *m_new_smap;
+  const sm_state_map<path_var> &m_old_smap;
+  sm_state_map<path_var> *m_new_smap;
   impl_4::stmt_finder *m_stmt_finder;
 };
 
@@ -1849,29 +2232,27 @@ public:
 /* FIXME.  */
 
 program_state::program_state (const extrinsic_state &ext_state)
-: m_path_state ()
+: m_path_state (),
+  m_region_model (NULL)
 {
-  int num_states = ext_state.m_checkers.length ();
-  for (int i = 0; i < num_states; i++)
-    m_checker_states.safe_push (new sm_state_map ());
-}
-
-/* FIXME.  */
+  if (flag_analyzer_region_model)
+    m_region_model = new region_model ();
 
-program_state::program_state (int num_states)
-: m_path_state ()
-{
+  int num_states = ext_state.m_checkers.length ();
   for (int i = 0; i < num_states; i++)
-    m_checker_states.safe_push (new sm_state_map ());
+    m_checker_states.safe_push (new sm_state_map<path_var> ());
 }
 
 /* FIXME.  */
 
 program_state::program_state (const program_state &other)
-: m_path_state (other.m_path_state)
+: m_path_state (other.m_path_state),
+  m_region_model (other.m_region_model
+		  ? new region_model (*other.m_region_model)
+		  : NULL)
 {
   int i;
-  sm_state_map *smap;
+  sm_state_map<path_var> *smap;
   FOR_EACH_VEC_ELT (other.m_checker_states, i, smap)
     m_checker_states.safe_push (smap->clone ());
 }
